 function implode(glue, pieces) {
  //  discuss at: http://phpjs.org/functions/implode/
  // original by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
  // improved by: Waldo Malqui Silva
  // improved by: Itsacon (http://www.itsacon.net/)
  // bugfixed by: Brett Zamir (http://brett-zamir.me)
  //   example 1: implode(' ', ['Kevin', 'van', 'Zonneveld']);
  //   returns 1: 'Kevin van Zonneveld'
  //   example 2: implode(' ', {first:'Kevin', last: 'van Zonneveld'});
  //   returns 2: 'Kevin van Zonneveld'

  var i = '',
    retVal = '',
    tGlue = '';
  if (arguments.length === 1) {
    pieces = glue;
    glue = '';
  }
  if (typeof pieces === 'object') {
    if (Object.prototype.toString.call(pieces) === '[object Array]') {
      return pieces.join(glue);
    }
    for (i in pieces) {
      retVal += tGlue + pieces[i];
      tGlue = glue;
    }
    return retVal;
  }
  return pieces;
}

function str_split(string, split_length) {
  //  discuss at: http://phpjs.org/functions/str_split/
  // original by: Martijn Wieringa
  // improved by: Brett Zamir (http://brett-zamir.me)
  // bugfixed by: Onno Marsman
  //  revised by: Theriault
  //  revised by: Rafal Kukawski (http://blog.kukawski.pl/)
  //    input by: Bjorn Roesbeke (http://www.bjornroesbeke.be/)
  //   example 1: str_split('Hello Friend', 3);
  //   returns 1: ['Hel', 'lo ', 'Fri', 'end']

  if (split_length === null) {
    split_length = 1;
  }
  if (string === null || split_length < 1) {
    return false;
  }
  string += '';
  var chunks = [],
    pos = 0,
    len = string.length;
  while (pos < len) {
    chunks.push(string.slice(pos, pos += split_length));
  }

  return chunks;
}

function strangebase64(n)
	{
		d = [
			'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 
			'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 
			'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 
			'U', 'V', 'W', 'X', 'Y', 'Z', 'a', 'b', 'c', 'd', 
			'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 
			'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 
			'y', 'z', '+', '/' ];
		c = 1; r = '';
		while (c > 0)
		{
			c = Math.floor(n / 64);
            r = d[n%64] + r;
			n = c;
		}
		return r;
	}

//rc4
//http://pongwar.com/arc4/

function encrypt(msg,key) {
	var result;
	try {
     result=strToHex(cipher(msg, key));
       
	}
	catch(ex) {
		result="ERROR: " + ex;
	}
     return result;
}

function decrypt(msg,key) {
    	var result;
	try {
result=cipher(hexToStr(msg), key);
          return result;
	}
	catch(ex) {
		result="ERROR: " + ex;
	}
     return result;
}

function cipher(msg, key) {
	var state = initState(key);
	var x = 0;
	var y = 0;
	var temp = 0;
	var output = "";
	for (i = 0; i < msg.length; i = i + 1)
	{
		x = (x + 1) % 256;
		y = (state[x] + y) % 256;
		temp = state[x];
		state[x] = state[y];
		state[y] = temp;
		output = output + String.fromCharCode(msg.charCodeAt(i) ^ state[(state[x] + state[y]) % 256]);
	}
	return output;
}

function initState(key) {
	var state = new Array(255);
	if (key.length > 0) {
		var j = 0;
		var temp = 0;
		for (i = 0; i <= 255; i = i + 1) {
			state[i] = i;
		}
		for (i = 0; i <= 255; i = i + 1) {
			j = (j + state[i] + key.charAt(i % key.length).charCodeAt(0)) % 256;
			temp = state[i];
			state[i] = state[j];
			state[j] = temp;
		}
	} else {
		throw("Blank Key")
	}
	return state;
}

function strToHex(str) {
	var hex = "";
	for (i = 0; i < str.length; i = i + 1) {
		hex = hex + decToHex(str.charCodeAt(i));
	}
	return hex;
}

function hexToStr(hex) {
	var str = "";
	if (isValidHex(hex)) {
		for (i = 0; i < hex.length; i = i + 2) {
			str = str + String.fromCharCode(hexToDec(hex.substr(i, 2)));
		}
	}
	else {
		throw("Invalid Hex");
	}
	return str;
}

function decToHex(dec) {
	var hex = dec.toString(16);
	if (hex.length < 2) {
		hex = "0" + hex;
	}
	else if (hex.length > 2) {
		throw("Unsupported Input")
	}
	return hex;
}

function hexToDec(hex) {
	return parseInt(hex, 16);
}

function isValidHex(hex) {
	re = new RegExp(/^([a-fA-F0-9]{2})+$/);
	if (hex.match(re)) {
		isValid = true;
	}
	else {
		isValid = false;
	}
	return isValid;
}

//verhoeff
//https://sites.google.com/site/abapexamples/javascript/verhoeff-algorithm

var Verhoeff = {
        "d":[[0,1,2,3,4,5,6,7,8,9],
            [1,2,3,4,0,6,7,8,9,5],
            [2,3,4,0,1,7,8,9,5,6],
            [3,4,0,1,2,8,9,5,6,7],
            [4,0,1,2,3,9,5,6,7,8],
            [5,9,8,7,6,0,4,3,2,1],
            [6,5,9,8,7,1,0,4,3,2],
            [7,6,5,9,8,2,1,0,4,3],
            [8,7,6,5,9,3,2,1,0,4],
            [9,8,7,6,5,4,3,2,1,0]],
        "p":[[0,1,2,3,4,5,6,7,8,9],
            [1,5,7,6,2,8,3,0,9,4],
            [5,8,0,3,7,9,6,1,4,2],
            [8,9,1,6,0,4,3,5,2,7],
            [9,4,5,3,1,2,6,8,7,0],
            [4,2,8,6,5,7,3,9,0,1],
            [2,7,9,3,8,0,6,4,1,5],
            [7,0,4,6,9,1,3,2,5,8]],
        "j":[0,4,3,2,1,5,6,7,8,9],
        "check":function(str)
        {
            var c = 0;
            str.replace(/\D+/g,"").split("").reverse().join("").replace(/[\d]/g, function(u, i, o){
                c = Verhoeff.d[c][Verhoeff.p[i&7][parseInt(u,10)]];
            });
            return (c === 0);
           
        },
        "get":function(str){
            var c = 0;
            str.replace(/\D+/g,"").split("").reverse().join("").replace(/[\d]/g, function(u, i, o){
                c = Verhoeff.d[ c ][ Verhoeff.p[(i+1)&7][parseInt(u,10)] ];
            });
            return Verhoeff.j[c];
        }
    };

//ord
function ord(string) {
  //  discuss at: http://phpjs.org/functions/ord/
  // original by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
  // bugfixed by: Onno Marsman
  // improved by: Brett Zamir (http://brett-zamir.me)
  //    input by: incidence
  //   example 1: ord('K');
  //   returns 1: 75
  //   example 2: ord('\uD800\uDC00'); // surrogate pair to create a single Unicode character
  //   returns 2: 65536

  var str = string + '',
    code = str.charCodeAt(0);
  if (0xD800 <= code && code <= 0xDBFF) {
    // High surrogate (could change last hex to 0xDB7F to treat high private surrogates as single characters)
    var hi = code;
    if (str.length === 1) {
      // This is just a high surrogate with no following low surrogate, so we return its value;
      return code;
      // we could also throw an error as it is not a complete character, but someone may want to know
    }
    var low = str.charCodeAt(1);
    return ((hi - 0xD800) * 0x400) + (low - 0xDC00) + 0x10000;
  }
  if (0xDC00 <= code && code <= 0xDFFF) {
    // Low surrogate
    // This is just a low surrogate with no preceding high surrogate, so we return its value;
    return code;
    // we could also throw an error as it is not a complete character, but someone may want to know
  }
  return code;
}
//
//codigo de control

     function getChecksum(numautorizacion,numfactura,nitcliente,fecha,monto,clave){
 
     numfactura= numfactura+Verhoeff.get(numfactura);
     numfactura= numfactura+Verhoeff.get(numfactura);
     
     nitcliente= nitcliente+Verhoeff.get(nitcliente);
     nitcliente= nitcliente+Verhoeff.get(nitcliente);
     
     fecha= fecha+Verhoeff.get(fecha);
     fecha= fecha+Verhoeff.get(fecha);
     
     monto=monto.replace(",", ".");
     monto=parseFloat(monto);
     
    
     var decimal = monto - Math.floor(monto);
	 if (decimal >= 0.5){
		monto = Math.floor(monto)+1;
	 }else{
		monto = Math.floor(monto);
	 }
         monto = monto.toString();
	 
     monto= monto+Verhoeff.get(monto);
     monto= monto+Verhoeff.get(monto);
     suma = parseInt(numfactura) + parseInt(nitcliente) + parseInt(fecha) + parseInt(monto);
	 suma=  suma.toString()+Verhoeff.get(suma.toString());
	 suma=	suma+Verhoeff.get(suma);
	 suma=	suma+Verhoeff.get(suma);
	 suma=	suma+Verhoeff.get(suma);
	 suma=	suma+Verhoeff.get(suma);
	 dv=suma.substring(suma.length-5);
     var cads = [numautorizacion, numfactura, nitcliente, fecha, monto];
     var msg = '';
	 var p = 0;
     for (i=0; i<5; i++)
		{
			msg = msg+ cads[i] + clave.substr( p, 1+parseInt(dv.charAt(i)));
			p = p+1 + parseInt(dv.charAt(i));
		}
     
         var codif = encrypt( msg,clave+dv);
         codif=codif.toUpperCase();
       var st = 0;
    var sp = [0,0,0,0,0];
         codif_length = codif.length;
        
         for (i=0; i<codif_length; i++)
		{
    			st =st+ codif.charCodeAt(i);
            
			sp[i%5] = sp[i%5]+codif.charCodeAt(i);
		}

         
		stt = 0;
       
         for (i=0; i<5; i++){
			stt +=  Math.floor((st * sp[i]) / (1 + parseInt(dv.charAt(i))));
             
         }
         var result=implode('-', str_split(encrypt(strangebase64(stt.toString()),clave+dv).toUpperCase(),2));
     return result;
     
    }
